unit Principal;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ComCtrls, ToolWin, ImgList, StdCtrls,OleCtrls,
  SHDocVw, Menus,WBFuncs,Registry, Effects, XPMan,inifiles, FileCtrl,
  ExtCtrls;

type
  TMainForm = class(TForm)
    Button1: TButton;
    ProgressBar1: TProgressBar;
    PageControl1: TPageControl;
    StatusBar1: TStatusBar;
    XPManifest1: TXPManifest;
    ImageList1: TImageList;
    MainMenu1: TMainMenu;
    Arquivo1: TMenuItem;
    mNovaJanela: TMenuItem;
    Abrir1: TMenuItem;
    SalvarComo1: TMenuItem;
    N1: TMenuItem;
    Imprimir1: TMenuItem;
    VisualizarImpresso1: TMenuItem;
    ConfigurarPgina1: TMenuItem;
    N2: TMenuItem;
    Propriedades1: TMenuItem;
    N3: TMenuItem;
    CodigoFonte1: TMenuItem;
    N5: TMenuItem;
    Sair1: TMenuItem;
    Editar1: TMenuItem;
    Recortar1: TMenuItem;
    Copiar1: TMenuItem;
    Colar1: TMenuItem;
    N4: TMenuItem;
    LocalizaNestaPgina1: TMenuItem;
    N6: TMenuItem;
    Zoom1: TMenuItem;
    Zoom2: TMenuItem;
    N7: TMenuItem;
    Favoritos1: TMenuItem;
    AdicionarUmFavorito1: TMenuItem;
    OpenDialog1: TOpenDialog;
    TabSheet1: TTabSheet;
    WebBrowser1: TWebBrowser;
    NovaAba1: TMenuItem;
    CoolBar1: TCoolBar;
    ToolBar1: TToolBar;
    btnvoltar: TToolButton;
    btnavancar: TToolButton;
    btnparar: TToolButton;
    btnatualizar: TToolButton;
    ToolButton10: TToolButton;
    btnhome: TToolButton;
    btnprocurar: TToolButton;
    ToolButton11: TToolButton;
    btnimprimir: TToolButton;
    ComboBox1: TComboBox;
    FecharAba1: TMenuItem;
    Ajuda1: TMenuItem;
    Sobre1: TMenuItem;
    PopupMenu1: TPopupMenu;
    NovaAba2: TMenuItem;
    FecharAba2: TMenuItem;
    Timer1: TTimer;
    Edit1: TEdit;
    Atalhos1: TMenuItem;

    procedure btnvoltarClick(Sender: TObject);
    procedure btnavancarClick(Sender: TObject);
    procedure btnpararClick(Sender: TObject);
    procedure btnatualizarClick(Sender: TObject);
    procedure btnhomeClick(Sender: TObject);
    procedure btnprocurarClick(Sender: TObject);
    procedure btnimprimirClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure ComboBox1KeyPress(Sender: TObject; var Key: Char);
    procedure Button1Click(Sender: TObject);
    procedure WebBrowser1CommandStateChange(Sender: TObject;
      Command: Integer; Enable: WordBool);
    procedure WebBrowser1DocumentComplete(Sender: TObject;
      const pDisp: IDispatch; var URL: OleVariant);
    procedure WebBrowser1ProgressChange(Sender: TObject; Progress,
      ProgressMax: Integer);
    procedure FormResize(Sender: TObject);
    procedure WebBrowser1BeforeNavigate2(Sender: TObject;
      const pDisp: IDispatch; var URL, Flags, TargetFrameName, PostData,
      Headers: OleVariant; var Cancel: WordBool);
    procedure WebBrowser1StatusTextChange(Sender: TObject;
      const Text: WideString);
    procedure WebBrowser1TitleChange(Sender: TObject;
      const Text: WideString);
    procedure mNovaJanelaClick(Sender: TObject);
    procedure Abrir1Click(Sender: TObject);
    procedure SalvarComo1Click(Sender: TObject);
    procedure Imprimir1Click(Sender: TObject);
    procedure VisualizarImpresso1Click(Sender: TObject);
    procedure Propriedades1Click(Sender: TObject);
    procedure Sair1Click(Sender: TObject);
    procedure Recortar1Click(Sender: TObject);
    procedure Copiar1Click(Sender: TObject);
    procedure Colar1Click(Sender: TObject);
    procedure LocalizaNestaPgina1Click(Sender: TObject);
    procedure ConfigurarPgina1Click(Sender: TObject);
    procedure CodigoFonte1Click(Sender: TObject);
    procedure Zoom1Click(Sender: TObject);
    procedure Zoom2Click(Sender: TObject);
    procedure AdicionarUmFavorito1Click(Sender: TObject);
    procedure NovaAba1Click(Sender: TObject);
    procedure FecharAba1Click(Sender: TObject);
    procedure TabSheet1Show(Sender: TObject);
    procedure WebBrowser1NewWindow2(Sender: TObject; var ppDisp: IDispatch;
      var Cancel: WordBool);
    procedure AbriremNovaababeta1Click(Sender: TObject);
    procedure Sobre1Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure NovaAba2Click(Sender: TObject);
    procedure FecharAba2Click(Sender: TObject);
    procedure PageControl1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Timer1Timer(Sender: TObject);
    procedure ComboBox1KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure Edit1KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure Atalhos1Click(Sender: TObject);
  private
    { Private declarations }
    WebbrowserAtivo: TWebBrowser;
    AbaAtiva: TTabSheet;
    captionweb: string;
    //array_WebBrowser : array of TWebBrowser;
    array_WebBrowser: array[0..100] of TWebBrowser;

    procedure ShowdaABA(Sender: TObject);

    function RetornaSequenciaAbas : Integer;

    procedure CriaMenuFavoritos;
    procedure onclickMenu(Sender: TObject);

  public
    { Public declarations }
  end;

var
  MainForm: TMainForm;
  ini: Tinifile;
  iniconfig: Tinifile;
  link:String;
implementation

uses Unit1, Math, Unit2;

{$R *.dfm}

procedure ExibirURLsVisitadas(Urls: TStrings);
var
Reg: TRegistry;
S: TStringList;
i: Integer;
begin
Reg := TRegistry.Create;
try
Reg.RootKey := HKEY_CURRENT_USER;
if Reg.OpenKey('Software\Microsoft\Internet '+
'Explorer\TypedURLs', False) then
begin
S := TStringList.Create;
try
reg.GetValueNames(S);
for i := 0 to S.Count - 1 do
begin
Urls.Add(reg.ReadString(S.Strings[i]));
end;
finally
S.Free;
end;
Reg.CloseKey;
end;
finally
Reg.Free;
end;
end;

procedure TMainForm.btnvoltarClick(Sender: TObject);
begin
//Serve para Voltar  pgina anteriormente visitada.
webbrowserativo.goback;
end;

procedure TMainForm.btnavancarClick(Sender: TObject);
begin
//Serve para vanar para a prxima pgina.
webbrowserativo.GoForward;
end;

procedure TMainForm.btnpararClick(Sender: TObject);
begin
//Serve para parar a pgina que est sendo carregada.
webbrowserativo.Stop;
end;

procedure TMainForm.btnatualizarClick(Sender: TObject);
begin
//Serve para Atualizar a pgina Atual
webbrowserativo.Refresh;
end;

procedure TMainForm.btnhomeClick(Sender: TObject);
begin
//Serve para ir at a pgina inicial da internet
webbrowserativo.GoHome;
end;

procedure TMainForm.btnprocurarClick(Sender: TObject);
begin
// Essa funo, abre a pgina de pesquisa padro do IE.
webbrowserativo.GoSearch;
end;

procedure TMainForm.btnimprimirClick(Sender: TObject);
begin
WB_ShowPrintDialog(WebBrowserativo);
end;

procedure TMainForm.FormCreate(Sender: TObject);
var memo: Tmemo;
filebox1:TFileListBox;
ind:integer;
login:Tinifile;
begin
      //  memo:=Tmemo.Create(self);
   //login:=TIniFile.Create(ExtractFilePath(Application.ExeName)+'visitas.ini');
   //if not login.SectionExists('entrada') then begin
   //Showmessage('Estamos copiando os favoritos do internet explorer !');

  // memo.Lines.Clear;
  // memo.Clear;
   //memo.Lines.Add('copy %useprofile%\favoritos ' +Extractfilepath(application.ExeName));
   //memo.Lines.SaveToFile(ExtractFilePath(application.ExeName)+'importar.bat');
//WinExec('importar.bat',SW_SHOWNORMAL);
 //FreeAndNil(memo);
 //iniconfig.Writeinteger('config1','importafav',1);
 // end;
  //end;
  //Screen.Cursors[1] := LoadCursor(HInstance, PChar('WEB'));
//  btnvoltar.Cursor:=1;
  ExibirURLsVisitadas(combobox1.Items);
  WebbrowserAtivo:=webbrowser1;
  abaAtiva:= TabSheet1;
  webbrowserativo.GoHome;
  CriaMenuFavoritos;
  if ParamCount > 0 then
  WebBrowserativo.Navigate(ParamStr(1));

//INI.Create(ExtractFilePath(application.ExeName) +'config.lsn');
end;

procedure TMainForm.ComboBox1KeyPress(Sender:TObject; var Key: Char);
begin
  if (key=#13) then
  begin

    webbrowserativo.Navigate(combobox1.Text);
    PageControl1.ActivePage.Caption := combobox1.Text;
  end;
end;

procedure TMainForm.Button1Click(Sender: TObject);
begin
  webbrowserativo.Navigate(combobox1.Text);
end;

procedure TMainForm.WebBrowser1CommandStateChange(Sender: TObject;
  Command: Integer; Enable: WordBool);
begin
  case Command of
    CSC_NAVIGATEBACK: begin
//Ativa e Desativa Automaticamente o Boto Voltar,
//Caso tenha alguma pgina para voltar
        BtnVoltar.Enabled := Enable;
      end;
    CSC_NAVIGATEFORWARD: begin
//Ativa e Desativa Automaticamente o Boto Avanar,
//Caso tenha alguma pgina para voltar
          BtnAvancar.Enabled := Enable;
      end;
  end;
end;

procedure TMainForm.WebBrowser1DocumentComplete(Sender: TObject;
  const pDisp: IDispatch; var URL: OleVariant);
begin
    ProgressBar1.Position := 0;
    StatusBar1.Panels[0].Text := '';
end;

procedure TMainForm.WebBrowser1ProgressChange
(Sender: TObject; Progress,ProgressMax: Integer);
begin
{Ele faz um rotina para saber se o valor Maximo do
Progressbar  maior que 1 e o valor minimo tbem
se for, ento ele faz a rotina}
   If (Progress>=1) and (ProgressMax>1)
    then
       begin
       //Ele tira uma valor percentual para colocar
       //no Progressbar
         ProgressBar1.Position := Round((Progress * 100)
         Div ProgressMax);
         ProgressBar1.Visible  := True;
        end
   else
      begin
          ProgressBar1.Position := 1;
          ProgressBar1.Visible  := False;
      end;
end;

procedure TMainForm.FormResize(Sender: TObject);
var
  r: TRect;
const
  SB_GETRECT = WM_USER + 10;
begin
  // Set Progressbar Position
  Statusbar1.Perform(SB_GETRECT, 1, Integer(@R));
  ProgressBar1.Parent := Statusbar1;
  ProgressBar1.SetBounds(r.Left, r.Top,
  r.Right - r.Left - 5, r.Bottom - r.Top);
  webbrowserativo.Height:=abaativa.Height;
  webbrowserativo.Width:=abaativa.Width;
end;

procedure TMainForm.WebBrowser1BeforeNavigate2(Sender: TObject;
  const pDisp: IDispatch; var URL, Flags, TargetFrameName,
  PostData,Headers: OleVariant; var Cancel: WordBool);
begin
{Ao Nevagar uma pgina, ele coloca automaticamente
o endereo dela no combobox, para sabermos que pgina
estamos entrando, o endereo da mesma}
combobox1.Text:=url;
end;

procedure TMainForm.WebBrowser1StatusTextChange(Sender:
TObject;
  const Text: WideString);
begin
StatusBar1.Panels[0].Text:=text;
if Copy(Text,1,7)='http://' then
link:=Text;
if Copy(Text,1,7)='ftp://' then
link:=text;
if Copy(Text,1,7)='https://' then
link:=text;
end;

procedure TMainForm.WebBrowser1TitleChange(Sender: TObject;
  const Text: WideString);
begin
  MainForm.Caption:=text + ' - Lucas Site Navigator Ultimate';
  abaativa.Caption:=text;
  captionweb:=text;
  application.Title:=text + ' - Lucas Site Navigator Ultimate';
end;

procedure TMainForm.mNovaJanelaClick(Sender: TObject);
  begin
    WinExec(pchar(application.exename),SW_MAXIMIZE);
end;

procedure TMainForm.Abrir1Click(Sender: TObject);
begin
  if OpenDialog1.Execute then
   webbrowserativo.Navigate(OpenDialog1.FileName) else
   exit;
end;

procedure TMainForm.SalvarComo1Click(Sender: TObject);
begin
  WB_Save(WebBrowserativo);
end;

procedure TMainForm.Imprimir1Click(Sender: TObject);
begin
  WB_ShowPrintDialog(WebBrowserativo);
end;

procedure TMainForm.VisualizarImpresso1Click(Sender: TObject);
begin
  WB_ShowPrintPreview(webbrowserativo);
end;

procedure TMainForm.Propriedades1Click(Sender: TObject);
begin
  WB_ShowPropertiesDialog(webbrowserativo);
end;

procedure TMainForm.Sair1Click(Sender: TObject);
begin
application.Terminate;
end;

procedure TMainForm.Recortar1Click(Sender: TObject);
begin
  WB_Cut(webbrowserativo);
end;

procedure TMainForm.Copiar1Click(Sender: TObject);
begin
  WB_Copy(webbrowserativo);
end;

procedure TMainForm.Colar1Click(Sender: TObject);
begin
  WB_paste(webbrowserativo);
end;

procedure TMainForm.LocalizaNestaPgina1Click(Sender: TObject);
begin
  WB_ShowFindDialog(webbrowserativo);
end;

procedure TMainForm.ConfigurarPgina1Click(Sender: TObject);
begin
  WB_ShowPageSetup(webbrowserativo);
end;

procedure TMainForm.CodigoFonte1Click(Sender: TObject);
begin
WB_ShowSourceCode(webbrowserativo);

end;

procedure TMainForm.Zoom1Click(Sender: TObject);
begin
WB_SetZoom(webBrowserativo,WB_GetZoom(webbrowserativo)+ 1);
end;

procedure TMainForm.Zoom2Click(Sender: TObject);
begin
 WB_SetZoom(webBrowserativo,WB_GetZoom(webbrowserativo)- 1);
end;

procedure TMainForm.AdicionarUmFavorito1Click(Sender: TObject);
var Ind : Integer;
    ItemMenu : TMenuItem;
begin
  //Se nao existe o diretrio - cria
  if not DirectoryExists(extractfilepath(application.ExeName) +'favoritos') then
    CreateDir(extractfilepath(application.ExeName) +'favoritos');

  if not FileExists(extractfilepath(application.ExeName) +'favoritos\' +Captionweb + '.url') then
  begin
    ItemMenu := TMenuItem.Create(MainMenu1);
    ItemMenu.Caption := Captionweb;
    ItemMenu.OnClick := onclickMenu;
    MainMenu1.Items[2].Add(ItemMenu);
  end;

  //Deleta o arquivo para cria-lo novamente (caso exista)
  DeleteFile(extractfilepath(application.ExeName) +'favoritos\' +Captionweb + '.url');
  //
  with tinifile.Create(extractfilepath(application.ExeName) +'favoritos\' +Captionweb + '.url') do
   WriteString('InternetShortcut','URL',combobox1.Text);
  //
  if fileexists(extractfilepath(application.ExeName) + 'favoritos\' + captionweb + '.url') then
  begin
    showmessage('Favorito Gravado !');
  end
  else
    Showmessage('Erro Ao Gravar Favorito');

end;


procedure NovaAba(Pagina: TPageControl; nomeAba: string; Donos: TCoolBar; Tools: TToolBar; Combo: TComboBox; Button: TToolButton);
var
Aba: TTabSheet;
PageControl1: TPageControl;
ImageList1: TImageList;
Web: TWebBrowser;
begin
Aba:= TTabSheet.Create(Pagina);
Aba.PageControl:=Pagina;
Aba.Caption:=nomeAba;

Combo:=TComboBox.create(combo);
Combo.Parent:=donos;
Combo.AutoDropDown:=True;

donos:= TCoolBar.create(donos);
donos.Parent := Aba;
donos.Bands.Add;
donos.Bands[0].text:='Endereo: ';
donos.Bands[0].Control:=Combo;

Tools:= TToolBar.create(Tools);
Tools.Parent :=Donos;
Tools.Cursor:=crArrow;
//Tools.Images:=ImageList1;
Tools.Flat:=True;
Tools.EdgeBorders:=[];
Tools.AutoSize:=true;
Tools.Height:=36;

Button:= TToolButton.Create(button);
Button.Parent:=Tools;
Button.Caption:='Voltar';
Button.hint:='Voltar para pgina anterior';
Button.ShowHint:=True;
Button.ImageIndex:=0;
Button.Width:=37;
Button.Height:=36;


web:=TWebbrowser.Create(aba);
web.Align:=AlClient;
web.GoHome;
Pagina.ActivePage:=Aba;

end;






procedure TMainForm.NovaAba1Click(Sender: TObject);
var
Aba: TTabSheet;
webbrowser: TWebBrowser;
Coolbar: Tcoolbar;
Combo: TComboBox;
toolbar: TToolBar;
begin
  Aba:=TTabSheet.Create(self);
  aba.PageControl:=PageControl1;
  aba.Name := 'TabSheet_' + IntToStr(PageControl1.PageCount);
  aba.Caption := 'Nova Aba';
  aba.Tag := PageControl1.PageCount;
  aba.OnShow:=ShowDaAba;
  webbrowser:=TWebBrowser.Create(nil); //WebBrowser1
  array_WebBrowser[PageControl1.PageCount] := webbrowser;
  webbrowser.GoHome;
  webbrowser.ParentWindow := ABA.Handle;
  WebbrowserAtivo := webbrowser;
  AbaAtiva:=aba;
  webbrowser.Height:=aba.Height;
  Webbrowser.Width:=aba.Width;
  //WebBrowser.Name := 'WebBrowser_' + IntToStr(Num)
  WebBrowser.Align:=AlClient;
  webbrowser.OnBeforeNavigate2:=WebBrowser1BeforeNavigate2;
  webbrowser.OnStatusTextChange:=WebBrowser1StatusTextChange;
  webbrowser.OnCommandStateChange:=WebBrowser1CommandStateChange;
  webbrowser.OnDocumentComplete:=WebBrowser1DocumentComplete;
  webbrowser.OnProgressChange:=WebBrowser1ProgressChange;
  webbrowser.OnTitleChange:=WebBrowser1TitleChange;
  webbrowser.OnNewWindow2:=WebBrowser1NewWindow2;
  PageControl1.ActivePage:=Aba;
 // NovaAba(pageControl1,'Nova Aba',CoolBar1,Toolbar1,Combobox1,btnVoltar);

end;

procedure TMainForm.FecharAba1Click(Sender: TObject);
var abasAtiva: TTabSheet;
begin
 abasativa:=PageControl1.ActivePage;
 abasativa.Destroy;
end;

procedure TMainForm.TabSheet1Show(Sender: TObject);
begin
  WebbrowserAtivo:=WebBrowser1;
  abaAtiva:=TabSheet1;
end;



procedure TMainForm.ShowdaABA(Sender: TObject);
begin
 WebbrowserAtivo := array_WebBrowser[(sender as TTabSheet).tag];
 abaAtiva:=sender as TTabSheet;
end;

function TMainForm.RetornaSequenciaAbas: Integer;
begin
  Result := 1;
end;

procedure TMainForm.CriaMenuFavoritos;
var Ind : Integer;
    ItemMenu : TMenuItem;
    IndInicial : Integer;
    FileListBox1 : TFileListBox;
begin
  //Primeiro remove os itens do menu favoritos
 // if MainMenu1.Items[2].Count > 1 then
  //begin
    //For Ind := 1 to MainMenu1.Items[2].Count -1 do
      //MainMenu1.Items[2].Remove(MainMenu1.Items[2].Items[Ind]);
 // end;

   if not DirectoryExists(extractfilepath(application.ExeName) +'favoritos') then
    CreateDir(extractfilepath(application.ExeName) +'favoritos');


  FileListBox1 := TFileListBox.Create(Self);
  FileListBox1.Parent := Self;
  FileListBox1.Visible := False;

  FileListBox1.Directory := ExtractFilePath(Application.ExeName) +'favoritos';
  FileListBox1.Mask := '*.url';
  FileListBox1.Refresh;
  ItemMenu := TMenuItem.Create(MainMenu1);
  ItemMenu.Caption := '-';
  MainMenu1.Items[2].Add(ItemMenu);

  For Ind := 0 to FileListBox1.Items.Count -1  do
  begin
    ItemMenu := TMenuItem.Create(MainMenu1);
    ItemMenu.Caption := Copy(FileListBox1.Items[Ind],1,Pos('.url',FileListBox1.Items[Ind]) -1);
    ItemMenu.OnClick := onclickMenu;
    MainMenu1.Items[2].Add(ItemMenu);
  end;
  //FreeAndNil(ItemMenu);
  FreeAndNil(FileListBox1);
end;

procedure TMainForm.onclickMenu(Sender: TObject);
var Arqini: TIniFile;
begin
  Arqini := TIniFile.Create(extractfilepath(application.ExeName) +'favoritos\' + StringReplace(TMenuItem(Sender).Caption,'&','',[rfReplaceAll]) + '.url');
  //ShowMessage(extractfilepath(application.ExeName) +'favoritos\' + StringReplace(TMenuItem(Sender).Caption,'&','',[rfReplaceAll]) + '.url');
  if Arqini.SectionExists('InternetShortcut') then
  begin
    ComboBox1.Text := (Arqini.ReadString('InternetShortcut','URL',''));
    webbrowserativo.Navigate(combobox1.Text);
  end;
  Arqini.Free;
  //ShowMessage('Click do menu: ' + );
end;

procedure TMainForm.WebBrowser1NewWindow2(Sender: TObject;
  var ppDisp: IDispatch; var Cancel: WordBool);
var
Aba: TTabSheet;
webbrowser: TWebBrowser;
Coolbar: Tcoolbar;
Combo: TComboBox;
toolbar: TToolBar;
begin
cancel:= true;
  Aba:=TTabSheet.Create(self);
  aba.PageControl:=PageControl1;
  aba.Name := 'TabSheet_' + IntToStr(PageControl1.PageCount);
  aba.Caption := 'Nova Aba';
  aba.Tag := PageControl1.PageCount;
  aba.OnShow:=ShowDaAba;
  webbrowser:=TWebBrowser.Create(nil); //WebBrowser1
  array_WebBrowser[PageControl1.PageCount] := webbrowser;
  webbrowser.ParentWindow := ABA.Handle;
  WebbrowserAtivo := webbrowser;
  AbaAtiva:=aba;
  webbrowser.Height:=aba.Height;
  Webbrowser.Width:=aba.Width;
  //WebBrowser.Name := 'WebBrowser_' + IntToStr(Num)
  WebBrowser.Align:=AlClient;
  webbrowser.OnBeforeNavigate2:=WebBrowser1BeforeNavigate2;
  webbrowser.OnStatusTextChange:=WebBrowser1StatusTextChange;
  webbrowser.OnCommandStateChange:=WebBrowser1CommandStateChange;
  webbrowser.OnDocumentComplete:=WebBrowser1DocumentComplete;
  webbrowser.OnProgressChange:=WebBrowser1ProgressChange;
  webbrowser.OnTitleChange:=WebBrowser1TitleChange;
  webbrowser.OnNewWindow2:=WebBrowser1NewWindow2;
  webbrowser.Navigate(link);
 // else Showmessage('O comando no conseguiu enterpretar o link');
 // Showmessage('O comando ainda esta em fase de testes e pode no funcionar :(');
  PageControl1.ActivePage:=Aba;

end;

procedure TMainForm.AbriremNovaababeta1Click(Sender: TObject);
var
Aba: TTabSheet;
webbrowser: TWebBrowser;
Coolbar: Tcoolbar;
Combo: TComboBox;
toolbar: TToolBar;
begin
  Aba:=TTabSheet.Create(self);
  aba.PageControl:=PageControl1;
  aba.Name := 'TabSheet_' + IntToStr(PageControl1.PageCount);
  aba.Caption := 'Nova Aba';
  aba.Tag := PageControl1.PageCount;
  aba.OnShow:=ShowDaAba;
  webbrowser:=TWebBrowser.Create(nil); //WebBrowser1
  array_WebBrowser[PageControl1.PageCount] := webbrowser;
// webbrowser .Navigate();
  webbrowser.ParentWindow := ABA.Handle;
  WebbrowserAtivo := webbrowser;
  AbaAtiva:=aba;
  webbrowser.Height:=aba.Height;
  Webbrowser.Width:=aba.Width;
  //WebBrowser.Name := 'WebBrowser_' + IntToStr(Num)
  WebBrowser.Align:=AlClient;
  webbrowser.OnBeforeNavigate2:=WebBrowser1BeforeNavigate2;
  webbrowser.OnStatusTextChange:=WebBrowser1StatusTextChange;
  webbrowser.OnCommandStateChange:=WebBrowser1CommandStateChange;
  webbrowser.OnDocumentComplete:=WebBrowser1DocumentComplete;
  webbrowser.OnProgressChange:=WebBrowser1ProgressChange;
  webbrowser.OnTitleChange:=WebBrowser1TitleChange;
  webbrowser.OnNewWindow2:=WebBrowser1NewWindow2;
  webbrowser.Navigate(statusbar1.Panels[0].Text);
  PageControl1.ActivePage:=Aba;

end;

procedure TMainForm.Sobre1Click(Sender: TObject);
begin
aboutbox.show;
end;

procedure TMainForm.FormShow(Sender: TObject);
var ind: integer; filelistbox1:TFileListBox;
begin
  //iniconfig.Create(extractfilepath(application.ExeName) +'config.ini');
  //if  ini.ReadInteger('config1','importafav',0) =0 then begin
  // if MessageDlg('Deseja importar os favoritos do internet explorer ?',mtConfirmation,[mbyes,mbno],0) = mryes then begin
   //  FileListBox1 := TFileListBox.Create(Self);
 // FileListBox1.Parent := Self;
  //FileListBox1.Visible := False;

  //FileListBox1.Directory :='C:\Documents and Settings\Lucas\Favoritos' ;
  //FileListBox1.Mask := '*.url';
  //FileListBox1.Refresh;
   //for ind:= 0 to filelistbox1.items.Count - 1 do
   //CopyFile(pchar(filelistbox1.Items[ind]),pchar(ExtractFilepath(application.ExeName)),true);
   //FreeAndNil(filelistbox1);
//  end;
  //end;
end;

procedure TMainForm.NovaAba2Click(Sender: TObject);
var
Aba: TTabSheet;
webbrowser: TWebBrowser;
Coolbar: Tcoolbar;
Combo: TComboBox;
toolbar: TToolBar;
begin
  Aba:=TTabSheet.Create(self);
  aba.PageControl:=PageControl1;
  aba.Name := 'TabSheet_' + IntToStr(PageControl1.PageCount);
  aba.Caption := 'Nova Aba';
  aba.Tag := PageControl1.PageCount;
  aba.OnShow:=ShowDaAba;
  webbrowser:=TWebBrowser.Create(nil); //WebBrowser1
  array_WebBrowser[PageControl1.PageCount] := webbrowser;
  webbrowser.GoHome;
  webbrowser.ParentWindow := ABA.Handle;
  WebbrowserAtivo := webbrowser;
  AbaAtiva:=aba;
  webbrowser.Height:=aba.Height;
  Webbrowser.Width:=aba.Width;
  //WebBrowser.Name := 'WebBrowser_' + IntToStr(Num)
  WebBrowser.Align:=AlClient;
  webbrowser.OnBeforeNavigate2:=WebBrowser1BeforeNavigate2;
  webbrowser.OnStatusTextChange:=WebBrowser1StatusTextChange;
  webbrowser.OnCommandStateChange:=WebBrowser1CommandStateChange;
  webbrowser.OnDocumentComplete:=WebBrowser1DocumentComplete;
  webbrowser.OnProgressChange:=WebBrowser1ProgressChange;
  webbrowser.OnTitleChange:=WebBrowser1TitleChange;
  webbrowser.OnNewWindow2:=WebBrowser1NewWindow2;
  PageControl1.ActivePage:=Aba;

end;

procedure TMainForm.FecharAba2Click(Sender: TObject);
begin
AbaAtiva.Destroy;
end;

procedure TMainForm.PageControl1MouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
If button=mbright then
PopupMenu1.Popup(abaativa.Top,abaativa.Left);
end;

procedure TMainForm.Timer1Timer(Sender: TObject);
begin
if statusbar1.Panels[0].Text='Concludo' then
Statusbar1.Panels[0].Text:='Carregamento da pagina '+Captionweb+' Concluido - Lucas Site Navigator Ultimate';
end;

procedure TMainForm.ComboBox1KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
if (Shift=[ssShift]) and (key=vk_left) then
if btnvoltar.Enabled=true then
btnvoltar.Click;
if (Shift=[ssShift]) and (key=VK_right) then
if btnavancar.Enabled=true then
btnavancar.Click;
if (key=VK_F5) then
btnatualizar.Click;
if (Shift=[ssctrl]) and (key=84) then
NovaAba1.Click;
if (Shift=[ssctrl]) and (key=vk_tab) then
pagecontrol1.ActivePageIndex:=pagecontrol1.ActivePageIndex + 1;
if (Shift=[ssctrl]) and (key=87) then
FecharAba1.Click;

end;

procedure TMainForm.Edit1KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
if key=VK_Return then
Webbrowserativo.Navigate('http://www.google.com.br/search?hl=pt-BR&source=hp&q=' +widestring(edit1.Text));
end;

procedure TMainForm.Atalhos1Click(Sender: TObject);
begin
 form2.Show;
end;

end.
